// Verilated -*- C++ -*-
// DESCRIPTION: Verilator output: Design implementation internals
// See Vtop.h for the primary calling header

#include "Vtop.h"              // For This
#include "Vtop__Syms.h"

//--------------------
// STATIC VARIABLES


//--------------------

VL_CTOR_IMP(Vtop) {
    Vtop__Syms* __restrict vlSymsp = __VlSymsp = new Vtop__Syms(this, name());
    Vtop* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Reset internal values
    
    // Reset structure values
    clk = VL_RAND_RESET_I(1);
    rst = VL_RAND_RESET_I(1);
    dcsb_dat_o = VL_RAND_RESET_I(32);
    dcsb_adr_o = VL_RAND_RESET_I(32);
    dcsb_cyc_o = VL_RAND_RESET_I(1);
    dcsb_stb_o = VL_RAND_RESET_I(1);
    dcsb_we_o = VL_RAND_RESET_I(1);
    dcsb_sel_o = VL_RAND_RESET_I(4);
    dcsb_cab_o = VL_RAND_RESET_I(1);
    dcsb_dat_i = VL_RAND_RESET_I(32);
    dcsb_ack_i = VL_RAND_RESET_I(1);
    dcsb_err_i = VL_RAND_RESET_I(1);
    dc_en = VL_RAND_RESET_I(1);
    dcqmem_adr_i = VL_RAND_RESET_I(32);
    dcqmem_cycstb_i = VL_RAND_RESET_I(1);
    dcqmem_ci_i = VL_RAND_RESET_I(1);
    dcqmem_we_i = VL_RAND_RESET_I(1);
    dcqmem_sel_i = VL_RAND_RESET_I(4);
    dcqmem_tag_i = VL_RAND_RESET_I(4);
    dcqmem_dat_i = VL_RAND_RESET_I(32);
    dcqmem_dat_o = VL_RAND_RESET_I(32);
    dcqmem_ack_o = VL_RAND_RESET_I(1);
    dcqmem_rty_o = VL_RAND_RESET_I(1);
    dcqmem_err_o = VL_RAND_RESET_I(1);
    dcqmem_tag_o = VL_RAND_RESET_I(4);
    spr_cs = VL_RAND_RESET_I(1);
    spr_write = VL_RAND_RESET_I(1);
    spr_dat_i = VL_RAND_RESET_I(32);
    v__DOT__from_dcram = VL_RAND_RESET_I(32);
    v__DOT__dc_addr = VL_RAND_RESET_I(32);
    v__DOT__dcfsm_biu_read = VL_RAND_RESET_I(1);
    v__DOT__dcfsm_biu_write = VL_RAND_RESET_I(1);
    v__DOT__dcfsm_first_hit_ack = VL_RAND_RESET_I(1);
    v__DOT__dcfsm_first_miss_ack = VL_RAND_RESET_I(1);
    v__DOT__dcfsm_first_miss_err = VL_RAND_RESET_I(1);
    v__DOT__dcfsm_burst = VL_RAND_RESET_I(1);
}

void Vtop::__Vconfigure(Vtop__Syms* vlSymsp, bool first) {
    if (0 && first) {}  // Prevent unused
    this->__VlSymsp = vlSymsp;
}

Vtop::~Vtop() {
    delete __VlSymsp; __VlSymsp=NULL;
}

// Coverage
void Vtop::__vlCoverInsert(uint32_t* countp, bool enable, const char* filenamep, int lineno, int column,
    const char* hierp, const char* pagep, const char* commentp) {
    static uint32_t fake_zero_count = 0;
    if (!enable) countp = &fake_zero_count;
    *countp = 0;
    SP_COVER_INSERT(countp,  "filename",filenamep,  "lineno",lineno,  "column",column,
	"hier",string(name())+hierp,  "page",pagep,  "comment",commentp);
}

//--------------------


void Vtop::eval() {
    Vtop__Syms* __restrict vlSymsp = this->__VlSymsp; // Setup global symbol table
    Vtop* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Initialize
    if (VL_UNLIKELY(!vlSymsp->__Vm_didInit)) _eval_initial_loop(vlSymsp);
    // Evaluate till stable
    VL_DEBUG_IF(VL_PRINTF("\n----TOP Evaluate Vtop::eval\n"); );
    int __VclockLoop = 0;
    IData __Vchange=1;
    while (VL_LIKELY(__Vchange)) {
	VL_DEBUG_IF(VL_PRINTF(" Clock loop\n"););
	vlSymsp->__Vm_activity = true;
	_eval(vlSymsp);
	__Vchange = _change_request(vlSymsp);
	if (++__VclockLoop > 100) vl_fatal(__FILE__,__LINE__,__FILE__,"Verilated model didn't converge");
    }
}

void Vtop::_eval_initial_loop(Vtop__Syms* __restrict vlSymsp) {
    vlSymsp->__Vm_didInit = true;
    _eval_initial(vlSymsp);
    vlSymsp->__Vm_activity = true;
    int __VclockLoop = 0;
    IData __Vchange=1;
    while (VL_LIKELY(__Vchange)) {
	_eval_settle(vlSymsp);
	_eval(vlSymsp);
	__Vchange = _change_request(vlSymsp);
	if (++__VclockLoop > 100) vl_fatal(__FILE__,__LINE__,__FILE__,"Verilated model didn't DC converge");
    }
}

//--------------------
// Internal Methods

void Vtop::_settle__TOP__1(Vtop__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_PRINTF("    Vtop::_settle__TOP__1\n"); );
    Vtop* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    vlTOPp->dcsb_adr_o = vlTOPp->v__DOT__dc_addr;
    vlTOPp->dcsb_dat_o = vlTOPp->dcqmem_dat_i;
    vlTOPp->dcsb_cab_o = ((IData)(vlTOPp->dc_en) & (IData)(vlTOPp->v__DOT__dcfsm_burst));
    vlTOPp->dcsb_we_o = ((IData)(vlTOPp->dc_en) ? (IData)(vlTOPp->v__DOT__dcfsm_biu_write)
			  : (IData)(vlTOPp->dcqmem_we_i));
    vlTOPp->dcsb_stb_o = ((IData)(vlTOPp->dc_en) ? 
			  ((IData)(vlTOPp->v__DOT__dcfsm_biu_read) 
			   | (IData)(vlTOPp->v__DOT__dcfsm_biu_write))
			   : (IData)(vlTOPp->dcqmem_cycstb_i));
    vlTOPp->dcqmem_dat_o = ((1 & ((IData)(vlTOPp->v__DOT__dcfsm_first_miss_ack) 
				  | (~ (IData)(vlTOPp->dc_en))))
			     ? vlTOPp->dcsb_dat_i : vlTOPp->v__DOT__from_dcram);
    vlTOPp->dcsb_cyc_o = ((IData)(vlTOPp->dc_en) ? 
			  ((IData)(vlTOPp->v__DOT__dcfsm_biu_read) 
			   | (IData)(vlTOPp->v__DOT__dcfsm_biu_write))
			   : (IData)(vlTOPp->dcqmem_cycstb_i));
    vlTOPp->dcsb_sel_o = (((((IData)(vlTOPp->dc_en) 
			     & (IData)(vlTOPp->v__DOT__dcfsm_biu_read)) 
			    & (~ (IData)(vlTOPp->v__DOT__dcfsm_biu_write))) 
			   & (~ (IData)(vlTOPp->dcqmem_ci_i)))
			   ? 0xf : (IData)(vlTOPp->dcqmem_sel_i));
    vlTOPp->dcqmem_ack_o = ((IData)(vlTOPp->dc_en) ? 
			    ((IData)(vlTOPp->v__DOT__dcfsm_first_hit_ack) 
			     | (IData)(vlTOPp->v__DOT__dcfsm_first_miss_ack))
			     : (IData)(vlTOPp->dcsb_ack_i));
    vlTOPp->dcqmem_err_o = ((IData)(vlTOPp->dc_en) ? (IData)(vlTOPp->v__DOT__dcfsm_first_miss_err)
			     : (IData)(vlTOPp->dcsb_err_i));
}

void Vtop::_combo__TOP__2(Vtop__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_PRINTF("    Vtop::_combo__TOP__2\n"); );
    Vtop* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    vlTOPp->dcsb_dat_o = vlTOPp->dcqmem_dat_i;
    vlTOPp->dcsb_cab_o = ((IData)(vlTOPp->dc_en) & (IData)(vlTOPp->v__DOT__dcfsm_burst));
    vlTOPp->dcsb_we_o = ((IData)(vlTOPp->dc_en) ? (IData)(vlTOPp->v__DOT__dcfsm_biu_write)
			  : (IData)(vlTOPp->dcqmem_we_i));
    vlTOPp->dcqmem_dat_o = ((1 & ((IData)(vlTOPp->v__DOT__dcfsm_first_miss_ack) 
				  | (~ (IData)(vlTOPp->dc_en))))
			     ? vlTOPp->dcsb_dat_i : vlTOPp->v__DOT__from_dcram);
    vlTOPp->dcsb_cyc_o = ((IData)(vlTOPp->dc_en) ? 
			  ((IData)(vlTOPp->v__DOT__dcfsm_biu_read) 
			   | (IData)(vlTOPp->v__DOT__dcfsm_biu_write))
			   : (IData)(vlTOPp->dcqmem_cycstb_i));
    vlTOPp->dcsb_stb_o = ((IData)(vlTOPp->dc_en) ? 
			  ((IData)(vlTOPp->v__DOT__dcfsm_biu_read) 
			   | (IData)(vlTOPp->v__DOT__dcfsm_biu_write))
			   : (IData)(vlTOPp->dcqmem_cycstb_i));
    vlTOPp->dcsb_sel_o = (((((IData)(vlTOPp->dc_en) 
			     & (IData)(vlTOPp->v__DOT__dcfsm_biu_read)) 
			    & (~ (IData)(vlTOPp->v__DOT__dcfsm_biu_write))) 
			   & (~ (IData)(vlTOPp->dcqmem_ci_i)))
			   ? 0xf : (IData)(vlTOPp->dcqmem_sel_i));
    vlTOPp->dcqmem_ack_o = ((IData)(vlTOPp->dc_en) ? 
			    ((IData)(vlTOPp->v__DOT__dcfsm_first_hit_ack) 
			     | (IData)(vlTOPp->v__DOT__dcfsm_first_miss_ack))
			     : (IData)(vlTOPp->dcsb_ack_i));
    vlTOPp->dcqmem_err_o = ((IData)(vlTOPp->dc_en) ? (IData)(vlTOPp->v__DOT__dcfsm_first_miss_err)
			     : (IData)(vlTOPp->dcsb_err_i));
    vlTOPp->dcqmem_rty_o = (1 & (~ (IData)(vlTOPp->dcqmem_ack_o)));
    vlTOPp->dcqmem_tag_o = ((IData)(vlTOPp->dcqmem_err_o)
			     ? 0xb : (IData)(vlTOPp->dcqmem_tag_i));
}

void Vtop::_settle__TOP__3(Vtop__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_PRINTF("    Vtop::_settle__TOP__3\n"); );
    Vtop* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    vlTOPp->dcqmem_rty_o = (1 & (~ (IData)(vlTOPp->dcqmem_ack_o)));
    vlTOPp->dcqmem_tag_o = ((IData)(vlTOPp->dcqmem_err_o)
			     ? 0xb : (IData)(vlTOPp->dcqmem_tag_i));
}

void Vtop::_eval(Vtop__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_PRINTF("    Vtop::_eval\n"); );
    Vtop* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    vlTOPp->_combo__TOP__2(vlSymsp);
}

void Vtop::_eval_initial(Vtop__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_PRINTF("    Vtop::_eval_initial\n"); );
    Vtop* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
}

void Vtop::final() {
    VL_DEBUG_IF(VL_PRINTF("    Vtop::final\n"); );
    // Variables
    Vtop__Syms* __restrict vlSymsp = this->__VlSymsp;
    Vtop* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
}

void Vtop::_eval_settle(Vtop__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_PRINTF("    Vtop::_eval_settle\n"); );
    Vtop* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    vlTOPp->_settle__TOP__1(vlSymsp);
    vlTOPp->_settle__TOP__3(vlSymsp);
}

IData Vtop::_change_request(Vtop__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_PRINTF("    Vtop::_change_request\n"); );
    Vtop* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    // Change detection
    IData __req = false;  // Logically a bool
    return __req;
}
